<?php
function dda_fetch_rss($url){
	$cache = 'RSS' . md5($url);
	$val = DDA_Cache::get($cache);
	if( $val )
		return $val;

	include_once (ABSPATH . 'wp-includes/rss.php');
	$val = fetch_rss($url);
	
	DDA_Cache::set($cache, $rss);
	
	return $val;
}
function dda_http($url, $method='GET', $data='', $headers = array()){
	global $wp_version;
	//Partly stolen from update checker code :)
	if( is_array($data) )
		$data = http_build_query($data);

	$allowed_methods = array('GET', 'POST', 'HEAD');
	if( ! in_array($method, $allowed_methods) ) $method = 'GET';

	$port = 80;
	$schema = 'http';
	$path = $host = '';
	$parts = parse_url($url);
	extract($parts);

	$http_request  = "$method $path?$query HTTP/1.0\r\n";
	$http_request .= "Host: $host\r\n";
	if( !empty($data) ){
		$http_request .= 'Content-Type: application/x-www-form-urlencoded; charset=' . get_option('blog_charset') . "\r\n";
		$http_request .= 'Content-Length: ' . strlen($request) . "\r\n";
	}
	$http_request .= 'User-Agent: WordPress/' . $wp_version . '; ' . 'dDeviantArt Plugin; ' . get_bloginfo('url') . "\r\n";
	//$http_request .= "User-Agent: Opera/9.50 (Windows NT 5.1; U; en;)\r\n";
	if( ! empty($headers) )
		foreach($headers as $header => $value)
			$http_request .= "$header: $value\r\n";
	$http_request .= "\r\n";
	if( !empty($data) )
		$http_request .= $request;

	$response = '';
	if( false == ( $fs = @fsockopen( $host, $port, $errno, $errstr, 3) ) || ! is_resource($fs) )
		return false;

	fwrite($fs, $http_request);

	while ( !feof($fs) )
		$response .= fgets($fs, 1160); // One TCP-IP packet
	fclose($fs);

	$response = explode("\r\n\r\n", $response, 2);
	$ret = (object)array('headers' => array(), 'content'=> $response[1]);
	
	$headers = explode("\n", $response[0]);
	foreach( $headers as $rheader){
		list($header, $value) = explode(':', $rheader, 2);
		if( !empty($header) && ! empty($value) ) {
			$ret->headers[ trim($header) ] = trim($value);
		} else if( strpos($rheader, 'HTTP') > -1) {
			list(,$status, $status_name) = preg_split('|\s+|', $rheader);
			$ret->headers[ 'Status' ] = $status;
			$ret->headers[ 'Status-Name' ] = $status_name;
		}
	}
	return $ret;
}
?>